/* FILE: xpfloat.h                    -*-Mode: c++-*-
 *
 * Class for extended floating point precision using
 * compensated summation.
 * 
 * NOTICE: Please see the file ../../LICENSE
 *
 * Last modified on: $Date: 1999/09/21 21:32:02 $
 * Last modified by: $Author: donahue $
 */

#include "oc.h"

#ifndef _NB_XPFLOAT_H
#define _NB_XPFLOAT_H

class Nb_Xpfloat
{
private:
  REALWIDE x,corr;
public:
  Nb_Xpfloat(REALWIDE newx=0.0) { x=newx; corr=0.; }
  void Set(REALWIDE newx) { x=newx; corr=0.; }
  REALWIDE GetValue() const { return x; }
  void Accum(REALWIDE y);
  void Accum(const Nb_Xpfloat& y);
};

#endif // _NB_XPFLOAT_H
