/* FILE: autobuf.cc                   -*-Mode: c++-*-
 *
 * NOTICE: Please see the file ../../LICENSE
 *
 * Last modified on: $Date: 1999/02/25 00:41:05 $
 * Last modified by: $Author: dgp $
 */

/* Standard libraries */
#include <string.h>

/* Other classes and functions in this extension */
#include "autobuf.h"
#include "imports.h"

/* End includes */     

void Oc_AutoBuf::Dup(const char* const_str)
{
  int needsize=strlen(const_str)+1;
  if(needsize>bufsize) {
    if(bufsize>0) delete[] str;
    bufsize=needsize;
    str=new char[bufsize];
    if(str==0)
      panic((char *)"No memory in Oc_AutoBuf::Dup");
  }
  strcpy(str,const_str);
}
 
Oc_AutoBuf::Oc_AutoBuf()
{
  bufsize=0;
  str=NULL; // Safety
  Dup("");
}
 
Oc_AutoBuf::Oc_AutoBuf(const char* const_str)
{
  bufsize=0;
  str=NULL; // Safety
  Dup(const_str);
}
 
char* Oc_AutoBuf::operator()(const char* const_str)
{
  Dup(const_str);
  return str;
}
 
Oc_AutoBuf::~Oc_AutoBuf()
{
  delete[] str;
}

